diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/default-emlsr-manager.h ns-3.44/src/wifi/model/eht/default-emlsr-manager.h
--- ns-3.43/src/wifi/model/eht/default-emlsr-manager.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/default-emlsr-manager.h	2025-03-09 16:55:49.787372600 -0700
@@ -17,7 +17,7 @@
 {
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * DefaultEmlsrManager is the default EMLSR manager.
  */
@@ -25,62 +25,88 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     DefaultEmlsrManager();
     ~DefaultEmlsrManager() override;
 
+    void NotifyRtsSent(uint8_t linkId,
+                       Ptr<const WifiPsdu> rts,
+                       const WifiTxVector& txVector) override;
+
   protected:
     uint8_t GetLinkToSendEmlOmn() override;
     std::optional<uint8_t> ResendNotification(Ptr<const WifiMpdu> mpdu) override;
     std::pair<bool, Time> DoGetDelayUntilAccessRequest(uint8_t linkId) override;
     void SwitchMainPhyIfTxopGainedByAuxPhy(uint8_t linkId, AcIndex aci) override;
     std::pair<bool, Time> GetDelayUnlessMainPhyTakesOverUlTxop(uint8_t linkId) override;
+    void NotifyEmlsrModeChanged() override;
 
     /**
      * This function is intended to be called when an aux PHY is about to transmit an RTS on
      * the given link to calculate the time remaining to the end of the CTS reception.
      *
-     * \param linkId the ID of the given link
-     * \return the time remaining to the end of the CTS reception
+     * @param linkId the ID of the given link
+     * @return the time remaining to the end of the CTS reception
      */
     Time GetTimeToCtsEnd(uint8_t linkId) const;
 
     /**
+     * This function is intended to be called when an aux PHY is about to transmit an RTS on
+     * the given link to calculate the time remaining to the end of the CTS reception.
+     *
+     * @param linkId the ID of the given link
+     * @param rtsTxVector the TXVECTOR used to transmit the RTS
+     * @return the time remaining to the end of the CTS reception
+     */
+    Time GetTimeToCtsEnd(uint8_t linkId, const WifiTxVector& rtsTxVector) const;
+
+    /**
      * This method can only be called when aux PHYs do not switch link. Switch the main PHY back
-     * to the primary link and reconnect the aux PHY that was operating on the link left by the
+     * to the preferred link and reconnect the aux PHY that was operating on the link left by the
      * main PHY.
      *
-     * \param linkId the ID of the link that the main PHY is leaving
+     * @param linkId the ID of the link that the main PHY is leaving
+     * @param traceInfo information to pass to the main PHY switch traced callback (the fromLinkId
+     *                  and toLinkId fields are set by SwitchMainPhy)
      */
-    void SwitchMainPhyBackToPrimaryLink(uint8_t linkId);
+    void SwitchMainPhyBackToPreferredLink(uint8_t linkId, EmlsrMainPhySwitchTrace&& traceInfo);
 
-    /// Store information about a main PHY switch.
-    struct MainPhySwitchInfo
-    {
-        Time end;     //!< end of channel switching
-        uint8_t from; //!< ID of the link which the main PHY is/has been leaving
-    };
-
-    bool m_switchAuxPhy;  /**< whether Aux PHY should switch channel to operate on the link on which
-                               the Main PHY was operating before moving to the link of the Aux PHY */
-    bool m_auxPhyToSleep; //!< whether Aux PHY should be put into sleep mode while the Main PHY
-                          //!< is operating on the same link as the Aux PHY
-    EventId m_auxPhyToSleepEvent;     //!< the event scheduled to put an Aux PHY into sleep mode
+    bool m_switchAuxPhy; /**< whether Aux PHY should switch channel to operate on the link on which
+                              the Main PHY was operating before moving to the link of the Aux PHY */
     Ptr<WifiPhy> m_auxPhyToReconnect; //!< Aux PHY the ChannelAccessManager of the link on which
                                       //!< the main PHY is operating has to connect a listener to
                                       //!< when the main PHY is back operating on its previous link
     EventId m_auxPhySwitchEvent;      //!< event scheduled for an aux PHY to switch link
-    MainPhySwitchInfo m_mainPhySwitchInfo; //!< main PHY switch info
+    std::map<uint8_t, Time> m_switchMainPhyOnRtsTx; //!< link ID-indexed map of the time when an RTS
+                                                    //!< that requires the main PHY to switch link
+                                                    //!< is expected to be transmitted on the link
 
   private:
+    /**
+     * This function shall be called when the main PHY starts switching to a link on which an aux
+     * PHY that is capable of switching link is operating. This function schedules the aux PHY
+     * switch to occur when the main PHY completes the switch and, in case the connection of the
+     * main PHY to the aux PHY link is postponed because the aux PHY is receiving a PPDU, the
+     * aux PHY switch is postponed accordingly.
+     *
+     * @param auxPhy the aux PHY that has to switch link
+     * @param currLinkId the link on which the aux PHY is operating
+     * @param nextLinkId the link to which the aux PHY will switch
+     * @param duration the remaining time until the aux PHY switch starts
+     */
+    void SwitchAuxPhyAfterMainPhy(Ptr<WifiPhy> auxPhy,
+                                  uint8_t currLinkId,
+                                  uint8_t nextLinkId,
+                                  Time duration);
+
     void DoNotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId) override;
-    void NotifyEmlsrModeChanged() override;
     void NotifyMainPhySwitch(std::optional<uint8_t> currLinkId,
                              uint8_t nextLinkId,
+                             Ptr<WifiPhy> auxPhy,
                              Time duration) override;
     void DoNotifyIcfReceived(uint8_t linkId) override;
     void DoNotifyUlTxopStart(uint8_t linkId) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/eht-capabilities.cc ns-3.44/src/wifi/model/eht/eht-capabilities.cc
--- ns-3.43/src/wifi/model/eht/eht-capabilities.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/eht-capabilities.cc	2025-03-09 16:55:49.787372600 -0700
@@ -594,7 +594,7 @@
 }
 
 uint8_t
-EhtCapabilities::GetHighestSupportedRxMcs(EhtMcsAndNssSet::EhtMcsMapType mapType)
+EhtCapabilities::GetHighestSupportedRxMcs(EhtMcsAndNssSet::EhtMcsMapType mapType) const
 {
     const auto it = m_supportedEhtMcsAndNssSet.supportedEhtMcsAndNssSet.find(mapType);
     if (it == m_supportedEhtMcsAndNssSet.supportedEhtMcsAndNssSet.cend())
@@ -629,7 +629,7 @@
 }
 
 uint8_t
-EhtCapabilities::GetHighestSupportedTxMcs(EhtMcsAndNssSet::EhtMcsMapType mapType)
+EhtCapabilities::GetHighestSupportedTxMcs(EhtMcsAndNssSet::EhtMcsMapType mapType) const
 {
     const auto it = m_supportedEhtMcsAndNssSet.supportedEhtMcsAndNssSet.find(mapType);
     if (it == m_supportedEhtMcsAndNssSet.supportedEhtMcsAndNssSet.cend())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/eht-capabilities.h ns-3.44/src/wifi/model/eht/eht-capabilities.h
--- ns-3.43/src/wifi/model/eht/eht-capabilities.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/eht-capabilities.h	2025-03-09 16:55:49.787372600 -0700
@@ -39,21 +39,21 @@
     /**
      * Get the size of the serialized EHT MAC capabilities subfield
      *
-     * \return the size of the serialized EHT MAC capabilities subfield
+     * @return the size of the serialized EHT MAC capabilities subfield
      */
     uint16_t GetSize() const;
     /**
      * Serialize the EHT MAC capabilities subfield
      *
-     * \param start iterator pointing to where the EHT MAC capabilities subfield should be written
+     * @param start iterator pointing to where the EHT MAC capabilities subfield should be written
      * to
      */
     void Serialize(Buffer::Iterator& start) const;
     /**
      * Deserialize the EHT MAC capabilities subfield
      *
-     * \param start iterator pointing to where the EHT MAC capabilities subfield should be read from
-     * \return the number of bytes read
+     * @param start iterator pointing to where the EHT MAC capabilities subfield should be read from
+     * @return the number of bytes read
      */
     uint16_t Deserialize(Buffer::Iterator start);
 };
@@ -118,21 +118,21 @@
     /**
      * Get the size of the serialized EHT PHY capabilities subfield
      *
-     * \return the size of the serialized EHT PHY capabilities subfield
+     * @return the size of the serialized EHT PHY capabilities subfield
      */
     uint16_t GetSize() const;
     /**
      * Serialize the EHT PHY capabilities subfield
      *
-     * \param start iterator pointing to where the EHT PHY capabilities subfield should be written
+     * @param start iterator pointing to where the EHT PHY capabilities subfield should be written
      * to
      */
     void Serialize(Buffer::Iterator& start) const;
     /**
      * Deserialize the EHT PHY capabilities subfield
      *
-     * \param start iterator pointing to where the EHT PHY capabilities subfield should be read from
-     * \return the number of bytes read
+     * @param start iterator pointing to where the EHT PHY capabilities subfield should be read from
+     * @return the number of bytes read
      */
     uint16_t Deserialize(Buffer::Iterator start);
 };
@@ -162,20 +162,20 @@
     /**
      * Get the size of the serialized Supported EHT-MCS And NSS Set subfield
      *
-     * \return the size of the serialized Supported EHT-MCS And NSS Set  subfield
+     * @return the size of the serialized Supported EHT-MCS And NSS Set  subfield
      */
     uint16_t GetSize() const;
     /**
      * Serialize the Supported EHT-MCS And NSS Set subfield
      *
-     * \param start iterator pointing to where the Supported EHT-MCS And NSS Set subfield should be
+     * @param start iterator pointing to where the Supported EHT-MCS And NSS Set subfield should be
      * written to
      */
     void Serialize(Buffer::Iterator& start) const;
     /**
      * Deserialize the Supported EHT-MCS And NSS Set subfield
      *
-     * \param start iterator pointing to where the Supported EHT-MCS And NSS Set subfield should be
+     * @param start iterator pointing to where the Supported EHT-MCS And NSS Set subfield should be
      * read from \param is2_4Ghz indicating whether PHY is operating in 2.4 GHz based on previously
      * serialized IEs \param heSupportedChannelWidthSet supported channel width set based on
      * previously deserialized HE capabilities IE \param support320MhzIn6Ghz flag whether 320 MHz is
@@ -210,26 +210,26 @@
     /**
      * Get the size of the serialized EHT PPE Thresholds subfield
      *
-     * \return the size of the serialized EHT PPE Thresholds subfield
+     * @return the size of the serialized EHT PPE Thresholds subfield
      */
     uint16_t GetSize() const;
     /**
      * Serialize the EHT PPE Thresholds subfield
      *
-     * \param start iterator pointing to where the EHT PPE Thresholds subfield should be written to
+     * @param start iterator pointing to where the EHT PPE Thresholds subfield should be written to
      */
     void Serialize(Buffer::Iterator& start) const;
     /**
      * Deserialize the EHT PPE Thresholds subfield
      *
-     * \param start iterator pointing to where the EHT PPE Thresholds subfield should be read from
-     * \return the number of bytes read
+     * @param start iterator pointing to where the EHT PPE Thresholds subfield should be read from
+     * @return the number of bytes read
      */
     uint16_t Deserialize(Buffer::Iterator start);
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * The IEEE 802.11be EHT Capabilities
  */
@@ -243,9 +243,9 @@
     /**
      * Constructor
      *
-     * \param is2_4Ghz indicating whether PHY is operating in 2.4 GHz based on previously serialized
+     * @param is2_4Ghz indicating whether PHY is operating in 2.4 GHz based on previously serialized
      * IEs
-     * \param heCapabilities the optional HE capabilities contained in the same management frame
+     * @param heCapabilities the optional HE capabilities contained in the same management frame
      */
     EhtCapabilities(bool is2_4Ghz, const std::optional<HeCapabilities>& heCapabilities);
     // Implementations of pure virtual methods, or overridden from base class.
@@ -256,37 +256,37 @@
     /**
      * Set the maximum MPDU length.
      *
-     * \param length the maximum MPDU length (3895, 7991 or 11454)
+     * @param length the maximum MPDU length (3895, 7991 or 11454)
      */
     void SetMaxMpduLength(uint16_t length);
 
     /**
      * Set the maximum A-MPDU length.
      *
-     * \param maxAmpduLength 2^(23 + x) - 1, x in the range 0 to 1
+     * @param maxAmpduLength 2^(23 + x) - 1, x in the range 0 to 1
      */
     void SetMaxAmpduLength(uint32_t maxAmpduLength);
 
     /**
      * Return the maximum A-MPDU length.
      *
-     * \return the maximum A-MPDU length
+     * @return the maximum A-MPDU length
      */
     uint32_t GetMaxAmpduLength() const;
 
     /**
      * Get the maximum MPDU length.
      *
-     * \return the maximum MPDU length in bytes
+     * @return the maximum MPDU length in bytes
      */
     uint16_t GetMaxMpduLength() const;
 
     /**
      * Set a subfield of the Supported EHT-MCS And NSS Set.
      *
-     * \param mapType the type of the subfield
-     * \param upperMcs the upper MCS of the range
-     * \param maxNss the maximum NSS supported for transmission in the MCS range
+     * @param mapType the type of the subfield
+     * @param upperMcs the upper MCS of the range
+     * @param maxNss the maximum NSS supported for transmission in the MCS range
      */
     void SetSupportedTxEhtMcsAndNss(EhtMcsAndNssSet::EhtMcsMapType mapType,
                                     uint8_t upperMcs,
@@ -294,9 +294,9 @@
     /**
      * Set a subfield of the Supported EHT-MCS And NSS Set.
      *
-     * \param mapType the type of the subfield
-     * \param upperMcs the upper MCS of the range
-     * \param maxNss the maximum NSS supported for reception in the MCS range
+     * @param mapType the type of the subfield
+     * @param upperMcs the upper MCS of the range
+     * @param maxNss the maximum NSS supported for reception in the MCS range
      */
     void SetSupportedRxEhtMcsAndNss(EhtMcsAndNssSet::EhtMcsMapType mapType,
                                     uint8_t upperMcs,
@@ -305,24 +305,24 @@
     /**
      * Get the highest supported RX MCS for a given EHT-MCS map type.
      *
-     * \param mapType the EHT-MCS map type
-     * \return the highest supported RX MCS for the given EHT-MCS map type
+     * @param mapType the EHT-MCS map type
+     * @return the highest supported RX MCS for the given EHT-MCS map type
      */
-    uint8_t GetHighestSupportedRxMcs(EhtMcsAndNssSet::EhtMcsMapType mapType);
+    uint8_t GetHighestSupportedRxMcs(EhtMcsAndNssSet::EhtMcsMapType mapType) const;
     /**
      * Get the highest supported TX MCS for a given EHT-MCS map type.
      *
-     * \param mapType the EHT-MCS map type
-     * \return the highest supported TX MCS for the given EHT-MCS map type
+     * @param mapType the EHT-MCS map type
+     * @return the highest supported TX MCS for the given EHT-MCS map type
      */
-    uint8_t GetHighestSupportedTxMcs(EhtMcsAndNssSet::EhtMcsMapType mapType);
+    uint8_t GetHighestSupportedTxMcs(EhtMcsAndNssSet::EhtMcsMapType mapType) const;
 
     /**
      * Set the EHT PPE threshold info subfield
      *
-     * \param nssPe the NSS_PE subfield
-     * \param ruIndexBitmask the RU Index Bitmask subfield
-     * \param ppeThresholds the PPE thresholds made of pairs (PPETmax, PPET8)
+     * @param nssPe the NSS_PE subfield
+     * @param ruIndexBitmask the RU Index Bitmask subfield
+     * @param ppeThresholds the PPE thresholds made of pairs (PPETmax, PPET8)
      */
     void SetPpeThresholds(uint8_t nssPe,
                           uint8_t ruIndexBitmask,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/eht-configuration.h ns-3.44/src/wifi/model/eht/eht-configuration.h
--- ns-3.43/src/wifi/model/eht/eht-configuration.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/eht-configuration.h	2025-03-09 16:55:49.787372600 -0700
@@ -31,7 +31,7 @@
 static constexpr uint8_t DEFAULT_MSD_MAX_N_TXOPS = 1;
 
 /**
- * \brief TID-to-Link Mapping Negotiation Support
+ * @brief TID-to-Link Mapping Negotiation Support
  */
 enum class WifiTidToLinkMappingNegSupport : uint8_t
 {
@@ -58,16 +58,16 @@
 /**@}*/
 
 /**
- * \brief Stream insertion operator.
- * \param [in] os The reference to the output stream.
- * \param [in] negsupport The WifiTidToLinkMappingNegSupport.
- * \return The reference to the output stream.
+ * @brief Stream insertion operator.
+ * @param [in] os The reference to the output stream.
+ * @param [in] negsupport The WifiTidToLinkMappingNegSupport.
+ * @return The reference to the output stream.
  */
 std::ostream& operator<<(std::ostream& os, WifiTidToLinkMappingNegSupport negsupport);
 
 /**
- * \brief EHT configuration
- * \ingroup wifi
+ * @brief EHT configuration
+ * @ingroup wifi
  *
  * This object stores EHT configuration information, for use in modifying
  * AP or STA behavior and for constructing EHT-related information elements.
@@ -80,27 +80,26 @@
     ~EhtConfiguration() override;
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     /**
-     * \param dir the direction for the requested TID-to-Link Mapping
-     * \return a TID-indexed map of the list of links where each TID is mapped to
+     * @param dir the direction for the requested TID-to-Link Mapping
+     * @return a TID-indexed map of the list of links where each TID is mapped to
      */
     WifiTidLinkMapping GetTidLinkMapping(WifiDirection dir) const;
 
     /**
      * Set the TID-to-Link mapping for the given direction.
      *
-     * \param dir the direction for the TID-to-Link Mapping
-     * \param mapping a list-of-TIDs-indexed map of the list of links where the TIDs are mapped to
+     * @param dir the direction for the TID-to-Link Mapping
+     * @param mapping a list-of-TIDs-indexed map of the list of links where the TIDs are mapped to
      */
     void SetTidLinkMapping(WifiDirection dir,
                            const std::map<std::list<uint8_t>, std::list<uint8_t>>& mapping);
 
-  private:
     bool m_emlsrActivated;       //!< whether EMLSR option is activated
     Time m_transitionTimeout;    //!< Transition timeout
     Time m_mediumSyncDuration;   //!< duration of the MediumSyncDelay timer
